/*                                               */
/* Programme C: arbres.c                         */
/* pour les cours d'Informatique                 */
/* de l'Universite de Paris VII                  */
/*                                               */
/* (C) 2000 R. Di Cosmo (roberto@dicosmo.org)    */
/*                                               */
/* Programme distribue sous licence GPL          */
/*                                               */
/*  Creation et manipulation d'arbres binaires.  */

#include <stdio.h>
#include "arbres.h"

extern int dbg;
extern void debug(char c);
extern void checkchar(FILE *fp, char c);

/* constructeurs pour arbres */

intarbre empty()
{
return NULL;
}

intarbre node(int data,intarbre g, intarbre d)
{
  intarbre tmp;
  tmp=(intarbre) malloc(sizeof(nodearbre));
  tmp->data = data;
  tmp->fg=g;
  tmp->fd=d;
  return tmp;
}

/* test pour arbres */

int isempty (intarbre a)
{
return (a==NULL);
}

intlist lofa(intarbre a)
{
  if (isempty(a)) {return nil();}
  else {return cons(a->data,append(lofa(a->fg),lofa(a->fd)));};
}

void swap (intarbre *a, intarbre *b)
{
intarbre tmp;
tmp=*a;
*a=*b;
*b=tmp;
}


/* pour envoyer un arbre sur un fichier, et savoir la relire,
   mieux vaut choisir une syntaxe suffisamment abstraite (redondante) 
   par exemple: empty -> E()
                Node(v,a1,a2) -> N(a,...,...)
*/

void arbre_to_file(FILE *fp, intarbre a)
{
  if (isempty(a)) {fprintf(fp,"E()");}
  else {fprintf(fp,"N(%d,",a->data); 
        arbre_to_file(fp,a->fg);
        fprintf(fp,",");
        arbre_to_file(fp,a->fd);
        fprintf(fp,")");};
}

intarbre file_to_arbre(FILE *fp)
{char c;
 int v;
 intarbre res,tmp;

 if((c=fgetc(fp))==EOF){printf("EOF! J'abandonne\n");exit(1);};
 debug(c);
 switch (c) {
   case 'E': res=empty();checkchar(fp,'(');checkchar(fp,')');break;
   case 'N': checkchar(fp,'(');
             fscanf(fp,"%d",&v);
             checkchar(fp,',');
             tmp=file_to_arbre(fp);
             checkchar(fp,',');
             res=node(v,tmp,file_to_arbre(fp));
             checkchar(fp,')'); break;
 default: printf("Error de representation des donnees d'arbre!\n J'ai trouve: %c\n J'abandonne.\n",c); exit(1);
 }
 return res;
}


