/*                                               */
/* Programme C: listes.c                         */
/* pour les cours d'Informatique                 */
/* de l'Universite de Paris VII                  */
/*                                               */
/* (C) 2000 R. Di Cosmo (roberto@dicosmo.org)    */
/*                                               */
/* Programme distribue sous licence GPL          */
/*                                               */
/*  Creation et manipulation de listes.          */

#include <stdio.h>
#include "listes.h"

extern int dbg;
extern void debug(char c);
extern void checkchar(FILE *fp, char c);

/* constructeurs pour listes */

intlist nil()
{
return NULL;
}

intlist cons(int data,intlist l)
{
  intlist tmp;
  tmp=(intlist)malloc(sizeof(nodelist));
  tmp->data = data;
  tmp->suivant=l;
  return tmp;
}

/* test sur listes */

int isnil(intlist l)
{
  return(l==NULL);
}

/* fonctions (recursives ou pas) sur des listes */

/* attention, cette fonction fait UNE copie de l1, qu ise termine par un pointeur a l2 */
intlist append(intlist l1,intlist l2)
{
  if (isnil(l1)) {return l2;}
  else {return cons(l1->data,append(l1->suivant,l2));};
}

/* attention, cette fonction MODIFIE EN PLACE l1, pour qu'elle pointe sur l2 */
intlist append_it(intlist l1,intlist l2)
{ intlist res;
  res=l1;
  if (isnil(l1)) {return l2;}
  else {while (l1->suivant != NULL) {l1=l1->suivant;}; 
        l1->suivant=l2;};
  return res;
}

/* parcours d'une liste, et impression */
void printintlist (intlist l)
{
  while (!isnil(l)) {printf("%d ",l->data); l=l->suivant;};
}

/* pour envoyer une liste sur un fichier, et savoir la relire,
   mieux vaut choisir une syntaxe suffisamment abstraite (redondante) 
   par exemple: Nil -> N()
                Cons(a,l) -> C(a,... )
*/

void list_to_file(FILE *fp, intlist l)
{
  if (isnil(l)) {fprintf(fp,"N()");}
  else {fprintf(fp,"C(%d,",l->data); 
        list_to_file(fp,l->suivant);
        fprintf(fp,")");};
}

intlist file_to_list(FILE *fp)
{char c;
 int v;
 intlist res;

 if((c=fgetc(fp))==EOF){printf("EOF! J'abandonne\n");exit(1);};
 debug(c);
 switch (c) {
   case 'N': res=nil();checkchar(fp,'(');checkchar(fp,')');break;
   case 'C': checkchar(fp,'(');
             fscanf(fp,"%d",&v);
             checkchar(fp,',');
             res=cons(v,file_to_list(fp));
             checkchar(fp,')'); break;
 default: printf("Error de representation des donnees de liste!\n J'ai trouve: %c.\n J'abandonne.\n",c); exit(1);
 }
 return res;
}

